// Xbox DVD remote control program. - https://www.s-config.com/xbox-dvd-remote-everything/
// The purpose of this program is to use a TSOP38156-ND with the data line hooked to Pin 10 which will give us the ability to receive
// 50Khz Infra-RED. If you are using this tutorial for a standard remote. Then you can replace the transistor with a TSOP3448SS1F-ND
// or something similar in the 38Khz fashion that can accept a 5vdc signal or better. 
// 
// LED pin 13 in the onboard LED of the Arduino Leonardo's and their variant bootlegs. We used the Leonardo Arduino for it's HID functionality.
// 
//
// SPECIAL THANKS:
// https://uboopenfactory.univ-brest.fr/Les-Labs/MusicLab/Projets/Arduino-Media-Keys - Arduino Media Key Mapping
// http://www.asciitable.com/ - Standard HID key mapping.
// https://www.arduino.cc/en/Reference/KeyboardModifiers - Additional HID Key mappings that helped in previous projects.
// https://dronebotworkshop.com/using-ir-remote-controls-with-arduino/ - This is probably the best IR Remote tutorial site there is.
// https://github.com/NicoHood/HID - the Nico Hood HID Project for the 'customer' mappings for multimedia keys
// https://github.com/Arduino-IRremote/Arduino-IRremote - The specific library we used for thje IRremote. Not the default one in Arduino.
// https://github.com/NicoHood/HID/blob/master/src/KeyboardLayouts/ImprovedKeylayouts.h#L659 - Master-List of Improved Layouts.

#define HID_CUSTOM_LAYOUT                             //This is required for the Improved-HID-Library which works better with Linux and Android
#define LAYOUT_US_ENGLISH                             //Defining this allows us to call additional keys.

#include <IRremote.h>                                 //load the Ken Sherrifs IRremote library by Ken Shirriff
#include <HID-Project.h>                              //load NicoHood's HID Library 
int RECV_PIN = 10;                                    //Set the IRreceiver on pin 2 on the Arduino
int led = 13;                                         //LED for the power light on the Arduino

IRrecv irrecv(RECV_PIN);                              //Create an instance for irrecv
decode_results results;                               //Create an instance to store the collected data in

void setup() 
  {
        pinMode(led, OUTPUT);                         //Get the onboard LED going.
        // Serial.begin(9600);                        //start the serial monitor
        // Serial.println ("Press any button");       //print the line between the quotes
        irrecv.enableIRIn();                          //start the reciever
        Consumer.begin();                             //start the consumer HID keyboard for multimedia functionality.
        Keyboard.begin();                             //Also, start the regular keyboard HID
  }

void loop() 
  {
        if (irrecv.decode(&results))                  //this line checks if we received a signal from the IR receiver
          {
            // Serial.println(results.value, HEX);       //Print the value captured in HEX

         if (results.value == 0x8F3A25F9)             // 'Display' Key is pressed
            {
              //Keyboard.write(0x2F);                 // '\' key
              Consumer.write(0x40);                   // 'Menu' System Action.
              digitalWrite(led, HIGH);
            }
         if (results.value == 0xE8572B7A)             // 'Rewind' Key is pressed
            {
              //Keyboard.write(0x72);                 // 'r' key
              Consumer.write(0xB4);                   // 'MEDIA_REWIND' Action
              digitalWrite(led, HIGH);
            }
          if (results.value == 0x5A03C83E)            // 'Play' Key is pressed
            {
              //Keyboard.write(0x70);                 // 'p' key
              //Keyboard.write(MEDIA_PLAY_PAUSE);     // 'MEDIA_PLAY_PAUSE' Togglke Action - Only works on Linux and Android
              Consumer.write(0xCD);                   // 'MEDIA_PLAY_PAUSE' Togglke Action
              digitalWrite(led, HIGH);
            }
          if (results.value == 0x89DEE1B9)            // 'FastForward' Key is pressed
            {
              //Keyboard.write(0x66);                 // 'f' key
              //Keyboard.write(MEDIA_FAST_FOWARD);    // 'MEDIA_FAST_FOWARD' Toggle Action - Only works on Linux and Android
              Consumer.write(0xB3);                   // 'MEDIA_FAST_FOWARD' Toggle Action
              
              digitalWrite(led, HIGH);
            }
          if (results.value == 0x94DF0175)            // 'Skip Minus' Key is pressed
            {
              //Keyboard.write(0xD3);                 // 'PG-UP' key
              //Keyboard.write(MEDIA_PREVIOUS);       // 'MEDIA_PREVIOUS' Togglke Action - Only works on Linux and Android
              Consumer.write(0xB6);                   // 'MEDIA_PREVIOUS' Togglke Action
              digitalWrite(led, HIGH);
            }
          if (results.value == 0x32A6223E)            // 'Stop' Key is pressed
            {
              //Keyboard.write(0x78);                 // 'x' key
              //Keyboard.write(MEDIA_STOP);           // 'MEDIA_STOP' Togglke Action - Only works on Linux and Android
              Consumer.write(0xB7);                   // 'MEDIA_STOP' Togglke Action
              digitalWrite(led, HIGH);
            }
          if (results.value == 0xBAD4D9DE)            // 'Pause' Key is pressed
            {
              //Keyboard.write(0x20);                 // SpaceBar key
              //Keyboard.write(MEDIA_PLAY_PAUSE);     // 'MEDIA_PLAY_PAUSE' Toggle Action - Only works on Linux and Android
              Consumer.write(0xCD);                   // 'MEDIA_PLAY_PAUSE' Toggle Action
              digitalWrite(led, HIGH);
            }
          if (results.value == 0xC5EF9F9)             // 'Skip Plus' Key is pressed
            {
              //Keyboard.write(0xD6);                 // Page-Down key
              //Keyboard.write(MEDIA_NEXT);             // 'MEDIA_NEXT' Action - Only works on Linux and Android
              Consumer.write(0xB5);                   // 'MEDIA_NEXT' Action
              digitalWrite(led, HIGH);
            }
          if (results.value == 0x7A56B2D9)            // 'Title' Key is pressed
            {
              //Keyboard.write(0x63);                 // 'c' key
              Keyboard.write(0x63);                   // 'Menu' Action
              //Consumer.write(0x40);                 // 'Menu' Action - Not going to call it here as i'm using this on the 'DISPLAY' button
              digitalWrite(led, HIGH);
            } 
          if (results.value == 0xEEB21A42)            // 'Up' Key is pressed
            {
              Keyboard.write(KEY_UP_ARROW);           // 'up-arrow' key
              digitalWrite(led, HIGH);
             
            } 
          if (results.value == 0xBD0B58F5)            // 'info' Key is pressed
            {
              Keyboard.write(0x7A);                   // 'z' key
              digitalWrite(led, HIGH);
            }  
          if (results.value == 0xDAF86EDD)            // 'Left-Arrow' Key is pressed
            {
              Keyboard.write(KEY_LEFT_ARROW);                   // 'Left-Arrow' key
              digitalWrite(led, HIGH);
            } 
          if (results.value == 0xCEBCDBD9)            // 'Select' Key is pressed
            {
              Keyboard.write(KEY_ENTER);                   // 'Enter' key'
              digitalWrite(led, HIGH);
            }
          if (results.value == 0xBFA9B6DE)            // 'Right-Arrow' Key is pressed
            {
              Keyboard.write(KEY_RIGHT_ARROW);                   // 'Right-Arrow' key
              digitalWrite(led, HIGH);
            }
          if (results.value == 0xA11E6F9)             // 'menu' Key is pressed
            {
              Keyboard.write(0x6D);                 // 'm' key
              //Keyboard.write(MENU);                   // 'Menu' Action
              digitalWrite(led, HIGH);
            }  
          if (results.value == 0xA003A639)            // 'Down-Arrow' Key is pressed
            {
              Keyboard.write(KEY_DOWN_ARROW);                   // 'Down-Arrow' key
              digitalWrite(led, HIGH);
            } 
           if (results.value == 0x2EF93F1A)           // 'Back' Key is pressed
            {
              Keyboard.write(KEY_BACKSPACE);                   // 'BackSpace-0xB2' key
              digitalWrite(led, HIGH);
            }
           if (results.value == 0x49641316)           // '1' Key is pressed
            {
              //Keyboard.write(0x31);                 // '1' key
              Consumer.write(0x30);                   // 'Power' Action
              digitalWrite(led, HIGH);
            }
           if (results.value == 0x1CF35919)           // '2' Key is pressed
            {
              //Keyboard.write(0x32);                 // '2' key
              Consumer.write(0x61);                   // 'Closed-Caption' Action
              digitalWrite(led, HIGH);
            }
           if (results.value == 0xF14FF65A)           // '3' Key is pressed
            {
              //Keyboard.write(0x33);                 // '3' key
              //Keyboard.write(MEDIA_VOLUME_UP);      // 'MEDIA_VOLUME_UP' Action - Only works in Linux and Android
              Consumer.write(0xE9);                   // 'MEDIA_VOLUME_UP' Action
              digitalWrite(led, HIGH);
            }
           if (results.value == 0x3E81CB71)           // '4' Key is pressed
            {
              //Keyboard.write(0x34);                 // '4' key
              Consumer.write(0x31);                   // 'Reset' Action
              digitalWrite(led, HIGH);
            }
           if (results.value == 0x8D303F7A)           // '5' Key is pressed
            {
              //Keyboard.write(0x35);                 // '5' key
              Consumer.write(0x61);                   // 'Closed-Caption' Action
              digitalWrite(led, HIGH);
            }
           if (results.value == 0x39297135)           // '6' Key is pressed
            {
              //Keyboard.write(0x36);                 // '6' key
              Consumer.write(0xE2);                   // 'MEDIA_VOLUME_MUTE' Action
              //Keyboard.write(MEDIA_VOLUME_MUTE);    // 'MEDIA_VOLUME_MUTE' Action - Only works in Linux and Android
              digitalWrite(led, HIGH);
            }
           if (results.value == 0xD860E76)            // '7' Key is pressed
            {
              //Keyboard.write(0x37);                 // '7' key
              Consumer.write(0x32);                   // 'Sleep' Action
              digitalWrite(led, HIGH);
            }
           if (results.value == 0x8F890759)           // '8' Key is pressed
            {
              //Keyboard.write(0x38);                   // '8' key
              Keyboard.write(KEY_ESC);                   // 'Escape' key
              digitalWrite(led, HIGH);
            }
           if (results.value == 0xEE01511A)           // '9' Key is pressed
            {
              //Keyboard.write(0x39);                 // '9' key
              //Keyboard.write(MEDIA_VOLUME_DOWN);    // 'MEDIA_VOLUME_DOWN' Action - Only works in Linux and Android
              Consumer.write(0xEA);                   // 'MEDIA_VOLUME_DOWN' Action
              digitalWrite(led, HIGH);
            }
           if (results.value == 0xEAEBC955)           // '0' Key is pressed
            {
              //Keyboard.write(0x30);                 // '0' key
              Keyboard.write(HID_KEYBOARD_ESCAPE);                   // 'Escape' key
              digitalWrite(led, HIGH);
            }


            
            delay(100);                               // Debounce so we don't accidently double-press a button
            digitalWrite(led, LOW);                   // set the LED to low
            irrecv.resume();                          //receive the next value
          }
  }

  
